/*!
 * @file bolt.h
 * @brief light blaster bolt
*/

#ifndef _BOLT_H
#define _BOLT_H

#include "projectile.h"

class Vector;
class Weapon;
class SpriteParticles;
class ParticleEmitter;
class FastFactory;

class Bolt : public Projectile
{
  ObjectListDeclaration(Bolt);
  public:
    Bolt ();
    virtual ~Bolt ();


    virtual void activate();
    virtual void deactivate();

    virtual void collidesWith(WorldEntity* entity, const Vector& location);

    virtual void destroy (WorldEntity* killer);

    virtual void tick (float dt);
    virtual void draw () const;


  private:
    static FastFactory*               fastFactory;

    static SpriteParticles*           explosionParticles;

    ParticleEmitter*                  emitter;


    WorldEntity* hitEntity; // FIXME TEMPORARY
};

#endif /* _BOLT_H */
